/*

This program reads a function from a SmartDongle using the demo keys.
It then calls the function.

Copyright 2010 MicroWorks, Inc.

MicroWorks, Inc.
2808 North Cole Road
Boise, ID 83704
*/
#include <objbase.h>
#include <windows.h>
#include <setupapi.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <malloc.h>

#include <stdio.h>
#include <stdlib.h>
#include "smartdongle.h"
#include "devioctl.h"
#include "usb100.h"
#include "sd_cy7c63743.h"
#include "sd_cp2.h"
#include "sd_user.h"
#include "sd_eeprom.h"
#include "sd_uskerr.h"
#include "sd_helper.h"


int __cdecl main(int argc, char* argv[])
{
	int error;
	unsigned __int64 P1, P2;
	unsigned int iParm;
	unsigned int (* pRelocatableFunction)(unsigned int i);
	unsigned int iPrime;
	unsigned int iSize;

	if (argc != 2)                                       
	{
		printf ("Usage:  ReadFunction <##>\n");
		return (1);
	}

	// get the input parameter
	error = sscanf(argv[1], "%ud", &iParm);
	if (error != 1)
	{ // malloc failed
		printf ("Could not parse the input value\n", error);
		return 2;
	}
	SmartDongleLedOff();
	P1 = 0xec6cc589aefd1e75;
	P2 = 0xfcec0a6a82747b3f;
	SmartDongleLedGreen();

	// Read the function size from the SmartDongle
	error = SmartDongleRead(P1, P2, 0, (char *)&iSize, 4);
	if (error)
	{
		printf ("SmartDongleRead failed with return code %d\n", error);
	}

	// Get some memory for the function
	(char *)pRelocatableFunction = malloc (iSize);
	if (pRelocatableFunction == NULL)
	{ // malloc failed
		printf ("Malloc failed with return code %d\n", (int)pRelocatableFunction);
		return 3;
	}

	error = SmartDongleRead(P1, P2, 4, (char *)pRelocatableFunction, iSize);
	if (error)
	{
		printf ("SmartDongleRead failed with return code %d\n", error);
	}

	iPrime = pRelocatableFunction(iParm);
	if (iPrime == 0)
		SmartDongleLedRed();
	else
		SmartDongleLedGreen();

	printf ("Input %u  Output %u\n", iParm, iPrime);
	return iPrime;
}
